Bug 1729933 (CVE-2019-10639) - CVE-2019-10639 Kernel: net: using kernel space address bits to derive IP ID may potentially break KASLR
Summary: CVE-2019-10639 Kernel: net: using kernel space address bits to derive IP ID m...
Keywords:
Status: NEW
Alias: CVE-2019-10639
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1737436 1737437 1737438 1737439 1729934 1737440
Blocks: 1729937
TreeView+ depends on / blocked
 
Reported: 2019-07-15 11:16 UTC by Marian Rehak
Modified: 2019-09-29 15:16 UTC (History)
45 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
A flaw was found in the way the Linux kernel derived the IP ID field from a partial kernel space address returned by a net_hash_mix() function. A remote user could observe this IP ID field to extract the kernel address bits used to derive its value, which may result in leaking the hash key and potentially defeating KASLR.
Clone Of:
Environment:
Last Closed:


Attachments (Terms of Use)

Description Marian Rehak 2019-07-15 11:16:13 UTC
When IP packet fragmentation is ON, IP Identification(ID) field of the IP header 
is used, during packet reassembly on the destination host, to identify fragments 
which belong to the same packet. IP ID field is required to be unique and same 
across all fragments of an IP packet. IP packet fragments are identified by a 
tuple with following fields

    (source address|destination address|protocol|IP-ID)

The Linux kernel derived this IP ID field from partial kernel space address 
returned by net_hash_mix() function, which is then used with a hash function to 
compute the IP ID field.

A remote user could observe this IP ID field to deduce the kernel space address 
bits used to derive its value. Thus leaking the hash key and potentially 
defeating KASLR.

Upstream fix:
-------------
  -> https://git.kernel.org/linus/355b98553789b646ed97ad801a619ff898471b92

Issue introduced by:
--------------------
  -> https://git.kernel.org/linus/b6a7719aedd7e5c0f2df7641aa47386111682df4
  -> https://git.kernel.org/linus/5a352dd0a3aac03b443c94828dfd7144261c8636

Comment 1 Marian Rehak 2019-07-15 11:16:29 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1729934]

Comment 2 Prasad J Pandit 2019-07-28 08:11:16 UTC
External References:

https://arxiv.org/pdf/1906.10478.pdf

Comment 4 Prasad J Pandit 2019-08-06 06:58:51 UTC
Statement:

This issue does not affect the versions of Linux kernel as shipped with Red Hat Enterprise Linux 5 and Red Hat Enterprise Linux 6.

This issue affects the version of Linux kernel as shipped with Red Hat Enterprise Linux 7,  8 and Red Hat Enterprise MRG 2. Future kernel updates for Red Hat Enterprise Linux 7, 8 and Red Hat Enterprise MRG 2 may address this issue.


Note You need to log in before you can comment on or make changes to this bug.